unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Grids, ExtCtrls,Mak_met;

type
  TFMain = class(TForm)
    PMain: TPanel;
    SGTable: TStringGrid;
    BReadData: TButton;
    BStartSolve: TButton;
    BStandPrim: TButton;
    BAgain: TButton;
    BExit: TButton;
    BShag: TButton;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    GroupBox2: TGroupBox;
    Label2: TLabel;
    Memo1: TMemo;
    procedure BReadDataClick(Sender: TObject);
    procedure BStartSolveClick(Sender: TObject);
    procedure VivodPodcherkn;
    procedure VivodPodcherknOld;
    procedure VivodInA;
    procedure VivodAr;
    procedure BStandPrimClick(Sender: TObject);
    procedure BShagClick(Sender: TObject);
    procedure BExitClick(Sender: TObject);
    procedure BAgainClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FMain: TFMain;
  Tb:matrix;
  max_n:byte; // size of table
  in_a : byte; // kol-vo v A;
  A: matr_a;
  ar: koord_ar;
  ar_br:real;
  d:byte;
  c_ok: boolean;
  stop: boolean;
  ar_ok: boolean;

implementation

{$R *.dfm}

procedure TFMain.BReadDataClick(Sender: TObject);
var i,j:byte;
begin
  for i:=SGTable.ColCount downto 1 do
  begin
    max_n:=0;
    for j:=SGTable.RowCount downto 1 do
    if SGTable.Cells[i,j]<>'' then
    begin
     Tb[j,i].set_Znach(strtofloat(SGTable.Cells[i,j]));
     Tb[j,i].set_old_Znach(strtofloat(SGTable.Cells[i,j]));
     Tb[j,i].set_cherta(none);
     inc(Max_n);
   end;
 end;
 FindMin(tb,max_n);
 VivodPodcherkn;
end;

procedure TFMain.VivodPodcherkn;
var i,j:byte;
begin
  for i:=1 to max_n do
  for j:=1 to max_n do
    SGTable.Cells[i,j]:='';
  for i:=1 to max_n do
  for j:=1 to max_n do
  if tb[i,j].get_cherta=full then
    SGTable.Cells[j,i]:='___'+floattostr(tb[i,j].get_znach)+'___'
  else
  if tb[i,j].get_cherta=punktir then
    SGTable.Cells[j,i]:='....'+floattostr(tb[i,j].get_znach)+'....'
    else
    SGTable.Cells[j,i]:=floattostr(tb[i,j].get_znach);
end;

procedure TFMain.VivodPodcherknOld;
var i,j: byte;
    sum: real;
begin
 sum:=0;
 for i:=1 to max_n do
 for j:=1 to max_n do
  SGTable.Cells[i,j]:='';
 for i:=1 to max_n do
 for j:=1 to max_n do
 if tb[i,j].get_cherta=full then
 begin
   sum:=sum+tb[i,j].get_old_znach;
   SGTable.Cells[j,i]:='+++'+floattostr(tb[i,j].get_old_znach)+'+++'
 end  
 else
   SGTable.Cells[j,i]:=floattostr(tb[i,j].get_old_znach);
 Label2.Visible:=true;
 Label2.Caption:=Label2.Caption+'    : '+FloatTostr(sum)+' ..';
end;

procedure TFMain.VivodInA;
var i,j:byte;
begin
  for i:=1 to max_n do
  for j:=1 to max_n do
    SGTable.Cells[i,j]:='';
  for i:=1 to max_n do
  for j:=1 to in_a do
    SGTable.Cells[A[j],i]:=floattostr(tb[i,A[j]].get_znach);
end;

procedure TFMain.VivodAr;
var i,j:byte;
begin
  for i:=1 to max_n do
  for j:=1 to max_n do
    SGTable.Cells[i,j]:='';
  SGTable.Cells[ar.stl,ar.st]:=floattostr(tb[ar.st,ar.stl].get_znach);
end;

procedure TFMain.BStartSolveClick(Sender: TObject);
begin
 stop:=false;
 ProvVihod(stop,tb,max_n);
 while not(stop) do
 begin
   ChooseToA(A,in_a,tb,max_n);
   repeat
     c_ok:=true;
     FindAr(ar,ar_br,tb,max_n,in_a,A);
     //VivodAr;
     IncInA(tb,ar_br,A,max_n,in_a,ar);
     //VivodInA;
     MarkAr(tb,ar);
     AboutC(tb,ar,c_ok,a,in_a,max_n);
   until c_ok;
   repeat
     ar_ok:=true;
     PodcherkAr(tb,ar);
     DelPodcherk(tb,d,ar,max_n);
     FindInD(ar_ok,d,tb,max_n,ar);
   until ar_ok;
   ProvVihod(stop,tb,max_n);
   VivodPodcherkn;
  end;
  VivodPodcherknOld;
  BStartSolve.Enabled:=false;
end;


procedure TFMain.BShagClick(Sender: TObject);
begin
  stop:=false;
  ProvVihod(stop,tb,max_n);
  ChooseToA(A,in_a,tb,max_n);
  repeat
    c_ok:=true;
    FindAr(ar,ar_br,tb,max_n,in_a,A);
    //VivodAr;
    IncInA(tb,ar_br,A,max_n,in_a,ar);
    //VivodInA;
    MarkAr(tb,ar);
    AboutC(tb,ar,c_ok,a,in_a,max_n);
  until c_ok;
  repeat
    ar_ok:=true;
    PodcherkAr(tb,ar);
    DelPodcherk(tb,d,ar,max_n);
    FindInD(ar_ok,d,tb,max_n,ar);
  until ar_ok;
  ProvVihod(stop,tb,max_n);
  VivodPodcherkn;
  if stop then
  begin
    VivodPodcherknOld;
    BStartSolve.Enabled:=false;
    BShag.Enabled:=false;
  end;
end;

procedure TFMain.BStandPrimClick(Sender: TObject);
begin
 SGTable.Cells[1,1]:='10';
 SGTable.Cells[2,1]:='5';
 SGTable.Cells[3,1]:='9';
 SGTable.Cells[4,1]:='18';
 SGTable.Cells[5,1]:='11';
 SGTable.Cells[1,2]:='13';
 SGTable.Cells[2,2]:='19';
 SGTable.Cells[3,2]:='6';
 SGTable.Cells[4,2]:='12';
 SGTable.Cells[5,2]:='14';
 SGTable.Cells[1,3]:='3';
 SGTable.Cells[2,3]:='2';
 SGTable.Cells[3,3]:='4';
 SGTable.Cells[4,3]:='4';
 SGTable.Cells[5,3]:='5';
 SGTable.Cells[1,4]:='18';
 SGTable.Cells[2,4]:='9';
 SGTable.Cells[3,4]:='12';
 SGTable.Cells[4,4]:='17';
 SGTable.Cells[5,4]:='15';
 SGTable.Cells[1,5]:='11';
 SGTable.Cells[2,5]:='6';
 SGTable.Cells[3,5]:='14';
 SGTable.Cells[4,5]:='19';
 SGTable.Cells[5,5]:='10';

end;

procedure TFMain.BExitClick(Sender: TObject);
begin
 FMain.Close;
end;

procedure TFMain.BAgainClick(Sender: TObject);
var i,j:byte;
begin
  for i:=1 to max_n do
    for j:=1 to max_n do
  SGTable.Cells[i,j]:='';
  BShag.Enabled:=true;
  BStartSolve.Enabled:=true;
  Label2.Visible:=false;
  Label2.Caption:='!';
end;

procedure TFMain.FormCreate(Sender: TObject);
var i,j: byte;
begin
  SGTable.FixedColor:=clInactiveCaptionText;
  for i:=1 to n do
    SGTable.Cells[i,0]:=' '+IntToStr(i);
  for j:=1 to n do
    SGTable.Cells[0,j]:=' '+IntToStr(j);
end;

end.
